#ifndef _BUFFALO_GPIO_H_
#define _BUFFALO_GPIO_H_

unsigned int buffalo_gpio_read(void);
unsigned int buffalo_gpio_blink_reg_read(void);

unsigned int BuffaloGpio_CPUGetResetFlag(void);

void BuffaloGpio_CPUInterruptsSetup(void);
void BuffaloGpio_CPUInterruptsClear(void);
void BuffaloGpio_CPUInterruptsSetupInit(void);
void BuffaloGpio_CPUInterruptsClearInit(void);

void BuffaloGpio_Init(void);

void BuffaloGpio_AlarmLedEnable(void);
void BuffaloGpio_AlarmLedDisable(void);
void BuffaloGpio_AlarmLedBlinkEnable(void);
void BuffaloGpio_AlarmLedBlinkDisable(void);

void BuffaloGpio_InfoLedEnable(void);
void BuffaloGpio_InfoLedDisable(void);
void BuffaloGpio_InfoLedBlinkEnable(void);
void BuffaloGpio_InfoLedBlinkDisable(void);

void BuffaloGpio_PowerLedEnable(void);
void BuffaloGpio_PowerLedDisable(void);
void BuffaloGpio_PowerLedBlinkEnable(void);
void BuffaloGpio_PowerLedBlinkDisable(void);

void BuffaloGpio_HddPowerOn(void);
void BuffaloGpio_HddPowerOff(void);

void BuffaloGpio_CpuReset(void);
void BuffaloGpio_CpuResetClear(void);

void BuffaloGpio_AllLedOff(void);
unsigned int BuffaloGpio_IsCpuHotBoot(void);
uint8_t BuffaloGpio_ChangePowerStatus(uint8_t);

#define LGL_PCB_BA

#if defined LGL_PCB_AA
 #define BIT_HDD_PWR	2
 #define BIT_LED_INFO	3
 #define BIT_LED_ALARM	3
 #define BIT_POWER	11
#elif defined LGL_PCB_BA
 #define BIT_HDD_PWR	2
 #define BIT_LED_INFO	3
 #define BIT_LED_PWR	5
 #define BIT_LED_ALARM	6
 #define BIT_FAN_LCK	7
 #define BIT_INIT	10
 #define BIT_POWER 	12
 #define BIT_CPU_RESET	0
 #define BIT_LED_ETH	10 // dummy
#else
 #define BIT_HDD_PWR	2
 #define BIT_LED_INFO	3
 #define BIT_LED_ALARM	3
 #define BIT_POWER 11
#endif

#define ENABLE_POL 0 	/*high*/

#define BIT(x) (1<<x)

#define POWER_STATUS_REBOOTING			1
#define POWER_STATUS_REBOOTING_UBOOT_PASSED	2
#define POWER_STATUS_NORMAL_STATE		3
#define POWER_STATUS_HW_POWER_OFF		4
#define POWER_STATUS_SW_POWER_OFF		5
#define POWER_STATUS_SW_POFF_UBOOT_PASSED	6
#define POWER_STATUS_FWUPDATING			7
#define POWER_STATUS_REBOOT_REACHED_HALT	8
#define POWER_STATUS_SW_POFF_REACHED_HALT	9

#define MagicKeyReboot			0x18
#define MagicKeyRebootUbootPassed	0x3a
#define MagicKeyNormalState		0x71
#define MagicKeyHwPoff			0x43
#define MagicKeySwPoff			0x02
#define MagicKeySWPoffUbootPassed	0x5c
#define MagicKeyFWUpdating		0x6f
#define MagicKeyRebootReachedHalt	0x2b
#define MagicKeySWPoffReachedHalt	0x7a

#endif

